<?php
/*
Plugin Name: TimThumb for Events Manager
Plugin URI: http://wp-events-plugin.com
Description: The TimThumb Project was deprecated and therefore removed from Events Manager. This Re-Enables the use of TimThumb with Events Manager, USE AT YOUR OWN RISK!
Author: NetWebLogic
Author URI: http://wp-events-plugin.com/
Version: 1.0

Copyright (C) 2014 NetWebLogic LLC
*/

class EM_TimThumb {
    public static function init(){
        add_filter('em_location_output_placeholder','EM_TimThumb::placeholders',1,3);
        add_filter('em_category_output_placeholder','EM_TimThumb::placeholders',1,3);
        add_filter('em_event_output_placeholder','EM_TimThumb::placeholders',1,3);
    }
    
    public static function placeholders($replace, $EM_Object, $result){
        if ( preg_match("/#_(LOCATIONIMAGE|EVENTIMAGE|CATEGORYIMAGE)({([^}]+)})?/", $result, $placeholders) ) {
            $image_src = $EM_Object->get_image_url();
            if( !empty($image_src) && !empty($placeholders[3]) ){
                $image_size = explode(',', $placeholders[3]);
                if( EM_Object::array_is_numeric($image_size) && count($image_size) > 1 ){
                    if( $placeholders[1] == 'LOCATIONIMAGE' || $placeholders[1] == 'EVENTIMAGE' ){
                		if ( is_multisite() ) { //get the direct url as timthumb doesn't support redirect urls
                			global $blog_id;
                			$imageParts = explode('/blogs.dir/', $image_src);
                			if (isset($imageParts[1])) {
                				$image_src = network_site_url('/wp-content/blogs.dir/'. $imageParts[1]);
                			}
                		}
                    }
            		$width = ($image_size[0]) ? 'width="'.esc_attr($image_size[0]).'"':'';
            		$height = ($image_size[1]) ? 'height="'.esc_attr($image_size[1]).'"':'';
            	    $replace = "<img src='".esc_url(self::get_thumbnail_url($image_src, $image_size[0], $image_size[1]))."' $width $height />";
                }
            }
        }
	    return $replace;
    }
    
    public static function get_thumbnail_url($image_url, $width, $height){
    	return plugins_url('thumbnails/timthumb.php', __FILE__).'?src='.$image_url.'&amp;h='. $height .'&amp;w='. $width;
    }
}
add_action('init','EM_TimThumb::init');